nsBrowserStatusHandler.prototype.old_onLoacationChange = 
  nsBrowserStatusHandler.prototype.onLocationChange;
    
nsBrowserStatusHandler.prototype.onLocationChange = 
	function (aWebProgress, aRequest, aLocation) {
	  this.old_onLoacationChange(
	    aWebProgress,
	    aRequest,
	    aLocation
	    );
	  setTimeout(function () { updatePageTheme(); }, 0);
	}
    
document.getElementById("content").addEventListener(
  "load", 
  function(evt) { 
    setTimeout(function(event) {
      if (event.originalTarget == _content.document)
        updatePageTheme(); 
    }, 0, evt); 
  }, 
  true);

/* the rest is copied out of the Mozilla.org source tree:
 * mozilla/browser/base/content/browser.js
 * CVS tag: AVIARY_1_0_20040515_BRANCH
 * revision: r1.296.2.3.2.73
 * lines 5142 - 5297
 */

/* Begin Page Theme Functions */
function getStyleSheetArray(frame)
{
  var styleSheets = frame.document.styleSheets;
  var styleSheetsArray = new Array(styleSheets.length);
  for (var i = 0; i < styleSheets.length; i++) {
    styleSheetsArray[i] = styleSheets[i];
  }
  return styleSheetsArray;
}

function getAllStyleSheets(frameset)
{
  var styleSheetsArray = getStyleSheetArray(frameset);
  for (var i = 0; i < frameset.frames.length; i++) {
    var frameSheets = getAllStyleSheets(frameset.frames[i]);
    styleSheetsArray = styleSheetsArray.concat(frameSheets);
  }
  return styleSheetsArray;
}

function stylesheetFillPopup(menuPopup)
{
  var plainStyle = menuPopup.firstChild;
  var normalStyle = plainStyle.nextSibling;
  var sep = normalStyle.nextSibling;
  while (sep.nextSibling)
    menuPopup.removeChild(sep.nextSibling);

  var noOptionalStyles = true;
  var styleSheets = getAllStyleSheets(window._content);
  var currentStyleSheets = [];

  var allDisabled = true;
  var haveAltSheets = false;
  var haveAnyNonAltSheets = false;
  
  for (var i = 0; i < styleSheets.length; ++i) {
    var currentStyleSheet = styleSheets[i];
    
    // Skip any stylesheets that don't match the screen media type.
    var media = currentStyleSheet.media.mediaText.toLowerCase();
    if (media && (media.indexOf("screen") == -1) && (media.indexOf("all") == -1))
        continue;
        
    if (!currentStyleSheet.disabled)
        allDisabled = false;
        
    if (currentStyleSheet.title) {
      if (!currentStyleSheet.disabled)
        noOptionalStyles = false;

      haveAltSheets = true;
      
      var lastWithSameTitle = null;
      if (currentStyleSheet.title in currentStyleSheets)
        lastWithSameTitle = currentStyleSheets[currentStyleSheet.title];

      if (!lastWithSameTitle) {
        var menuItem = document.createElement("menuitem");
        menuItem.setAttribute("type", "radio");
        menuItem.setAttribute("label", currentStyleSheet.title);
        menuItem.setAttribute("data", currentStyleSheet.title);
        menuItem.setAttribute("checked", !currentStyleSheet.disabled);
        menuPopup.appendChild(menuItem);
        currentStyleSheets[currentStyleSheet.title] = menuItem;
      } else {
        if (currentStyleSheet.disabled)
          lastWithSameTitle.removeAttribute("checked");
      }
    }
    else 
       haveAnyNonAltSheets = true;
  }
  
  normalStyle.setAttribute("checked", noOptionalStyles && (!haveAnyNonAltSheets || !allDisabled));
  plainStyle.setAttribute("checked", allDisabled && haveAnyNonAltSheets);
  
  plainStyle.hidden = !haveAnyNonAltSheets;
  sep.hidden = !haveAltSheets;
}

function stylesheetInFrame(frame, title) {
  var docStyleSheets = frame.document.styleSheets;

  for (var i = 0; i < docStyleSheets.length; ++i) {
    if (docStyleSheets[i].title == title)
      return true;
  }
  return false;
}

function stylesheetSwitchFrame(frame, title) {
  var docStyleSheets = frame.document.styleSheets;

  for (var i = 0; i < docStyleSheets.length; ++i) {
    var docStyleSheet = docStyleSheets[i];

    if (title == "_nostyle")
      docStyleSheet.disabled = true;
    else if (docStyleSheet.title)
      docStyleSheet.disabled = (docStyleSheet.title != title);
    else if (docStyleSheet.disabled)
      docStyleSheet.disabled = false;
  }
}

function stylesheetSwitchAll(frameset, title) {
  if (!title || title == "_nostyle" || stylesheetInFrame(frameset, title)) {
    stylesheetSwitchFrame(frameset, title);
  }
  for (var i = 0; i < frameset.frames.length; i++) {
    stylesheetSwitchAll(frameset.frames[i], title);
  }
}

function updatePageTheme(evt)
{
  // XXX - Accessing window._content.document can generate an
  // onLocationChange for the current tab, this can cause the url
  // bar to be cleared. Prevent that happening by setting the clear
  // state to false for the duration of this function.
  var browser = getBrowser().selectedBrowser;
  var userTypedClear = browser.userTypedClear;
  browser.userTypedClear = false;

  if (!gPageThemeButton)
    gPageThemeButton = document.getElementById("page-theme-button");

  var hasThemes = false;
  var stylesheets = window._content.document.styleSheets;
  for (var i = 0; i < stylesheets.length; ++i) {
    var currentStyleSheet = stylesheets[i];
    
    if (currentStyleSheet.title) {
        // Skip any stylesheets that don't match the screen media type.
        var media = currentStyleSheet.media.mediaText.toLowerCase();
        if (media && (media.indexOf("screen") == -1) && (media.indexOf("all") == -1))
            continue;
        hasThemes = true;
        break;
    }
  }

  if (hasThemes) {
    gPageThemeButton.setAttribute("themes", "true");
    // FIXME: Do a first-time explanation of page themes here perhaps?
    // Avoid for now since Firebird's default home page has an alt sheet.
  }
  else
    gPageThemeButton.removeAttribute("themes");

  // Restore clear state
  browser.userTypedClear = userTypedClear;
}
/* End of the Page Theme functions */